[原创]POJ 2528 Mayor’s posters [线段树-区间更新+离散化]【数据结构】

2016-11-16 19:09:12 Tabris_ 阅读数:292


博客爬取于2020-06-14 22:42:34
以下为正文

版权声明:本文为Tabris原创文章,未经博主允许不得私自转载。
https://blog.csdn.net/qq_33184171/article/details/53190165


题目链接:http://poj.org/problem?id=2528
-------------------------------------------.
Mayor’s posters
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 60379 Accepted: 17492
Description

The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral wall for placing the posters and introduce the following rules:
Every candidate can place exactly one poster on the wall.
All posters are of the same height equal to the height of the wall; the width of a poster can be any integer number of bytes (byte is the unit of length in Bytetown).
The wall is divided into segments and the width of each segment is one byte.
Each poster must completely cover a contiguous number of wall segments.

They have built a wall 10000000 bytes long (such that there is enough place for all candidates). When the electoral campaign was restarted, the candidates were placing their posters on the wall and their posters differed widely in width. Moreover, the candidates started placing their posters on wall segments already occupied by other posters. Everyone in Bytetown was curious whose posters will be visible (entirely or in part) on the last day before elections.
Your task is to find the number of visible posters when all the posters are placed given the information about posters’ size, their place and order of placement on the electoral wall.
Input

The first line of input contains a number c giving the number of cases that follow. The first line of data for a single case contains number 1 <= n <= 10000. The subsequent n lines describe the posters in the order in which they were placed. The i-th line among the n lines contains two integer numbers li and ri which are the number of the wall segment occupied by the left end and the right end of the i-th poster, respectively. We know that for each 1 <= i <= n, 1 <= li <= ri <= 10000000. After the i-th poster is placed, it entirely covers all wall segments numbered li, li+1 ,… , ri.
Output

For each input data set print the number of visible posters after all the posters are placed.

The picture below illustrates the case of the sample input.

Sample Input

1
5
1 4
2 6
8 10
3 4
7 10
Sample Output

4
Source

Alberta Collegiate Programming Contest 2003.10.18
------------------------------------------.

题目大意:
就是给一个连续的区间,在上面的n个子区间(可覆盖)刷上n种颜色,问你最后漏出来的有几种颜色.

解题思路:
就是用线段树来维护每一个区间覆盖上颜色,最后计算叶子上的节点有几种颜色即可.

但是注意到l,rl,r范围有1e81e8这么大 但是n只有1e61e6
所以能够离散化一下计算.

注意的是离散化后的区间应该是2e62e6 不然RE

附本题代码
--------------------------------.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
/*
memory 2104kb
time 954ms
*/
//#include <bits/stdc++.h>
# include <stdio.h>
# include <string.h>
# include <iostream>
# include <algorithm>
# include <math.h>
# include <map>

# define abs(x) (((x)>0)?(x):-(x))
# define lalal puts("*********")
# define Rep(a,b,c) for(int a=(b);a<=(c);a++)
# define Req(a,b,c) for(int a=(b);a>=(c);a--)
# define Rop(a,b,c) for(int a=(b);a<(c);a++)
# define s1(a) scanf("%d",&a)
typedef long long int LL;
using namespace std;
const int inf = 0x3f3f3f3f;
const int MOD = 9901;
/**************************************/
const int N = 20000+5;
# define ll (rt<<1)
# define rr (rt<<1|1)
# define mid (tree[rt].m())
struct node
{
int l,r;
int lazy;
int m()
{
return (l+r)>>1;
}
int len()
{
return (r-l+1);
}
} tree[N<<2];

void build(int rt,int l,int r)
{
tree[rt].l=l,tree[rt].r=r,tree[rt].lazy=0;
if(l==r) return ;
build(ll,l,mid);
build(rr,mid+1,r);
}

void pushdown(int rt)
{
if(tree[rt].lazy)
{
tree[ll].lazy=tree[rr].lazy=tree[rt].lazy;
tree[rt].lazy=0;
}
}

void update(int rt,int L,int R,int val)
{
if(L<=tree[rt].l&&tree[rt].r<=R)
{
tree[rt].lazy=val;
return ;
}
pushdown(rt);
if(L<=mid) update(ll,L,R,val);
if(R >mid) update(rr,L,R,val);
}

int query(int rt,int L,int R)
{
if(tree[rt].l==tree[rt].r) return tree[rt].lazy;
pushdown(rt);
if(L<=mid) return query(ll,L,R);
if(R> mid) return query(rr,L,R);
}

map<int ,int >mp,mmp;
struct nod
{
int l,r;
int ind;
}b[N];
int c[N];
int main()
{
int _;
while(~s1(_))
{
while(_--)
{
mp.clear(),mmp.clear();
int n,kn=0,cnt=0,color=0;
s1(n);
int l,r;
Rep(i,1,n) s1(b[i].l),s1(b[i].r),c[i]=b[i].l,c[i+n]=b[i].r;
sort(c+1,c+n*2+1);
Rep(i,1,n<<1)if(0==mp[c[i]])mp[c[i]]=++kn;

build(1,1,kn);
Rep(i,1,n) update(1,mp[b[i].l],mp[b[i].r],i);

Rep(i,1,kn)
{
color=query(1,i,i);
if(mmp[color]==0)
mmp[color]=1,cnt++;
}
printf("%d\n",cnt);
}
}
return 0;
}